
using Base.Iterators
using Accessors
using Distributions
using Statistics, StatsBase
using Random
using LinearAlgebra
using StatsFuns
using PDMats
using Bijectors
using ProgressMeter
using Bootstrap
using Turing
using Optimisers
using LogDensityProblems
using ChainRulesCore

using Zygote
using ReverseDiff
using ForwardDiff

import DynamicPPL

include(srcdir("diagnostics.jl"))
include(srcdir("utils.jl"))
include(srcdir("piracy.jl"))
include(srcdir("gradient.jl"))
include(srcdir("flatten.jl"))
include(srcdir("sgd_bbvi.jl"))
include(srcdir("proximal.jl"))
include(srcdir("estimator.jl"))

include(srcdir("models/utils.jl"))
include(srcdir("models/datasets.jl"))
include(srcdir("models/linearreg.jl"))
include(srcdir("models/horseshoe.jl"))
include(srcdir("models/nnmf.jl"))
include(srcdir("models/bnn.jl"))
include(srcdir("models/radon.jl"))
include(srcdir("models/election.jl"))
include(srcdir("models/bradleyterry.jl"))
include(srcdir("models/autoregress.jl"))
